/* 
 * Copyright (c) 1995-1994 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */

#include <mach/machine/code16.h>

#include "config.h"
#include "i16_dos.h"


/* Real-mode program segment prefix segment.
   Initialized by i16_crt0.S before bss is cleared.  */
unsigned short psp_seg = -1;

/* Original real-mode environment segment,
   before DPMI gets a chance to mess it up.
   Initialized by i16_crt0.S before bss is cleared.  */
unsigned short environ_seg = -1;


CODE16

void i16_main(void)
{
	/* Make sure we're running on a good enough DOS version.  */
	if (i16_dos_version() < 0x300)
		i16_die("DOS 3.00 or higher required.");

	/* See if we're running in a DPMI or VCPI environment.
	   If either of these are successful, they don't return.  */
i16_puts("a");
	i16_dos_mem_check();
i16_puts("b");
#ifdef ENABLE_DPMI
	i16_dpmi_check();
i16_puts("c");
#endif
	i16_xms_check();
i16_puts("d");
	i16_ext_mem_check();
i16_puts("e");
#ifdef ENABLE_VCPI
	i16_vcpi_check();
#endif

i16_puts("f");
	i16_raw_start();
}

