
#include <mach/machine/asm.h>

#include "i386asm.h"

	.text

	/* We should never be entered this way.  */
	.globl	start,_start
start:
_start:
	jmp	boot_entry

	/* MultiBoot header - see multiboot.h.  */
	P2ALIGN(2)
boot_hdr:
	.long	0x1BADB002	/* magic */
#ifdef ELF
	.long	0x00000000	/* flags */
#else /* a.out kludge */
	.long	0x00010000	/* flags */
	.long	boot_hdr	/* header_addr */
	.long	_start		/* load_addr */
	.long	_edata		/* load_end_addr */
	.long	_end		/* bss_end_addr */
	.long	boot_entry	/* entry */
#endif

boot_entry:

	/* Switch to our own interrupt stack.  */
	movl	$_intstack+INTSTACK_SIZE,%esp

	/* Reset EFLAGS to a known state.  */
	pushl	$0
	popf

	/* Preserve the boot_info pointer.  */
	movl	%eax,%ebx

	/* Clear uninitialized data.  */
	lea	_edata,%edi
	lea	_end,%ecx
	subl	%edi,%ecx
	xorl	%eax,%eax
	rep
	stosb

	/* Jump into C code.  */
	pushl	%ebx
	call	EXT(c_boot_entry)

	.comm	_intstack,INTSTACK_SIZE

