/*
 * portio.h	Definitions of routines for detecting, reserving and
 *		allocating system resources.
 *
 * Version:	0.01	8/30/93
 *
 * Author:	Donald Becker (becker@super.org)
 */

#ifndef _LINUX_PORTIO_H
#define _LINUX_PORTIO_H

#define HAVE_PORTRESERVE
/*
 * Call check_region() before probing for your hardware.
 * Once you have found you hardware, register it with snarf_region().
 * If you unload the driver, use release_region to free ports.
 */
extern void linux_reserve_setup(char *str, int *ints);
extern int linux_check_region(unsigned int from, unsigned int extent);
extern void linux_snarf_region(unsigned int from, unsigned int extent);
extern void linux_request_region(unsigned int from,
				 unsigned int extent, const char *name);
extern void linux_release_region(unsigned int from, unsigned int extent);


#define HAVE_AUTOIRQ
extern void *linux_irq2dev_map[16];	/* Use only if you own the IRQ. */
extern void linux_autoirq_setup(int waittime);
extern int linux_autoirq_report(int waittime);

#ifndef LINUX_MACH_INCLUDE
#define reserve_setup	linux_reserve_setup
#define check_region	linux_check_region
#define snarf_region	linux_snarf_region
#define request_region	linux_request_region
#define release_region	linux_release_region
#define irq2dev_map	linux_irq2dev_map
#endif

#endif	/* _LINUX_PORTIO_H */
