#ifndef _LINUX_SKBUFF_H
#define _LINUX_SKBUFF_H

#include <linux/malloc.h>
#ifndef LINUX_MACH_INCLUDE
#include <linux/time.h>
#endif

#define HAVE_ALLOC_SKB

#define FREE_READ	1
#define FREE_WRITE	0

struct sk_buff_head {
	struct sk_buff * volatile next;
	struct sk_buff * volatile prev;
};


struct sk_buff {
	struct sk_buff * volatile next;
	struct sk_buff * volatile prev;
	unsigned char *data;
	unsigned long len;
	struct linux_device *dev;
	volatile char free;
	volatile char arp;
	unsigned short protocol;
	unsigned mach_len;
	void *mach_data;
};

extern struct sk_buff *linux_dev_alloc_skb(unsigned int size);
extern void linux_dev_kfree_skb(struct sk_buff *skb, int mode);

#ifndef LINUX_MACH_INCLUDE
#define alloc_skb(size, pri)	linux_dev_alloc_skb(size)
#define dev_alloc_skb		linux_dev_alloc_skb
#define kfree_skb		linux_dev_kfree_skb
#define dev_kfree_skb		linux_dev_kfree_skb

#define skb_reserve(skb, len)
#define skb_put(skb, len)	((void *) ((skb)->data))
#endif

#endif /* _LINUX_SKBUFF_H */
