/* 
 * Mach Operating System
 * Copyright (c) 1993,1991,1990,1989 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
/*
  Copyright 1988, 1989 by Intel Corporation, Santa Clara, California.

		All Rights Reserved

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appears in all
copies and that both the copyright notice and this permission notice
appear in supporting documentation, and that the name of Intel
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.

INTEL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL INTEL BE LIABLE FOR ANY SPECIAL, INDIRECT, OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

/*
 *  AT Hard Disk Driver
 *  Copyright Ing. C. Olivetti & S.p.A. 1989
 *  All rights reserved.
 *
 */
/*
  Copyright 1988, 1989 by Olivetti Advanced Technology Center, Inc.,
Cupertino, California.

		All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appears in all
copies and that both the copyright notice and this permission notice
appear in supporting documentation, and that the name of Olivetti
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.

  OLIVETTI DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL OLIVETTI BE LIABLE FOR ANY SPECIAL, INDIRECT, OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUR OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#if 0

#include <hd.h>

#include <sys/types.h>
#ifdef	MACH_KERNEL
#define PRIBIO 20
#include <device/buf.h>
#include <device/errno.h>
#include <device/device_types.h>
#include <device/disk_status.h>
#else	MACH_KERNEL
#include <sys/buf.h>
#include <sys/user.h> 
#endif	MACH_KERNEL
#include <sys/ioctl.h>
#include <i386/pio.h>
#include <i386/ipl.h>
#include <i386at/disk.h>
#include <chips/busses.h>
#include <i386at/hdreg.h>

#define LABEL_DEBUG(x,y) if (label_flag&x) y

/* From sys/systm.h */
struct buf *geteblk();

#define b_cylin		b_resid
#define PAGESIZ 4096

extern int devaddr[NHD/2];
extern int hdalive[NHD];
extern int hdgotvtoc[NHD];
extern struct hh hh[NHD/2];
extern struct alt_info alt_info[NHD];
extern struct buf hdbuf[NHD], hdunit[NHD];

extern int need_set_controller[NHD/2];

extern struct disklabel label[NHD];
extern int	   labeloffset[NHD];
extern int	   labelsector[NHD];

extern struct hd_param {
	unsigned short	ncyl;
	unsigned short	nheads;
	unsigned short	precomp;
	unsigned short	nsec;
	unsigned int    nsects;
	unsigned short  secsize;
}	        dosparm[NHD];

extern hdprobe(), hdslave(), hdintr();
int pchdminphys();
void pchdstrategy();
extern struct bus_device *hdinfo[NHD];

extern vm_offset_t	hd_std[NHD];
extern struct	bus_device *hd_dinfo[NHD*NDRIVES];
extern struct	bus_ctlr *hd_minfo[NHD];
extern struct	bus_driver	hddriver;

/*---------------------------------------------------------------------------*\
  pchdopen

  DESCRIPTION:
    inserted in the dev_ops structure of the dev_name_list entry of the device
    and called by ds_device_open. It actually opens the device.

  PARAMETERS:
    dev: [in] the number of the device to open.
    flags: [in] unused but present to be coherent with other open routines.

  RETURNS:
    0 if successful or ENXIO if not.
\*---------------------------------------------------------------------------*/
int
pchdopen(int dev, int flags)
{
  unsigned char unit = UNIT(dev);      /* device unit */ 
  unsigned char part = PARTITION(dev); /* partition number */

  /* check if the unit exists; no partition processing so no partition number
     is necessary (nor valid for that matter) */
  if(!hdalive[unit] || part != 0)
    return(ENXIO);

  return(0);
}

#ifdef	MACH_KERNEL
/*
 *	No need to limit IO size to 4096 bytes.
 */
int
pchdread(dev_t dev, io_req_t ior)
{
  return(block_io(pchdstrategy, minphys, ior));
}

int
pchdwrite(dev_t dev, io_req_t ior)
{
  return(block_io(pchdstrategy, minphys, ior));
}

#else	MACH_KERNEL

/* I really wonder what was the purpose of this section in the original pchd
   file. */
int
pchdminphys(bp)
struct buf *bp;
{
	if (bp->b_bcount > PAGESIZ)
		bp->b_bcount = PAGESIZ;
}

int
pchdread(dev,uio)
dev_t dev;
struct uio *uio;
{
  return(physio(pchdstrategy,&hdbuf[UNIT(dev)],dev,B_READ,pchdminphys,uio));
}

int
pchdwrite(dev,uio)
dev_t dev;
struct uio *uio;
{
  return(physio(pchdstrategy,&hdbuf[UNIT(dev)],dev,B_WRITE,pchdminphys,uio));
}

#endif	MACH_KERNEL


#ifdef	MACH_KERNEL
int pchd_abs_sec   = -1;
int pchd_abs_count = -1;
/* IOC_OUT only and not IOC_INOUT */

/*--------------------------------------------------------------------------*\
  pchdgetstat

  DESCRIPTION:
    returns some information on the hd device.

  PARAMETERS:
    dev: [in] the device to query.
    flavor: [in] the kind of info to retreive DEV_GET_SIZE to get the size
      of the disk, V_GETPARMS to get dosparm info or V_VERIFY to verify a
      portion of the disk.
    data: [out] the data retreived.
    count [in out] on entry the size of the data zone. On exit, the number
      of integers written in data.

  RETURNS:
    D_SUCCESS on success, an error code on error.
\*--------------------------------------------------------------------------*/
io_return_t
pchdgetstat(dev_t dev,int flavor,int *data, unsigned int *count)
{
  int			unit = UNIT(dev); /* the unit of the device */
  struct buf		*bp1;             /* an I/O buffer */
  int			i;                /* generic index */

  switch (flavor) {
    
  case DEV_GET_SIZE: { /* size query */
    data[DEV_GET_SIZE_DEVICE_SIZE] = dosparm[unit].nsects * 
      dosparm[unit].secsize; 
    data[DEV_GET_SIZE_RECORD_SIZE] = dosparm[unit].secsize;
    *count = DEV_GET_SIZE_COUNT;
    break;
  }

  case V_GETPARMS: {  /* dosparms query */
    struct disk_parms *dp;
    if (*count < sizeof (struct disk_parms)/sizeof(int))
      return (D_INVALID_OPERATION);
    dp = (struct disk_parms *) data;
    dp->dp_type = DPT_WINI;
    dp->dp_heads = 0;
    dp->dp_cyls = 0;
    dp->dp_sectors = 0;
    dp->dp_dosheads = dosparm[unit].nheads;
    dp->dp_doscyls = dosparm[unit].ncyl;
    dp->dp_dossectors  = dosparm[unit].nsec;
    dp->dp_secsiz = dosparm[unit].secsize;
    dp->dp_ptag = 0;
    dp->dp_pflag = 0;
    dp->dp_pstartsec = 0;
    dp->dp_pnumsec = dosparm[unit].nsects;
    *count = sizeof(struct disk_parms)/sizeof(int);
    break;
  }

    /* 
     * The followin option could be bumped out of the kernel really
     * since it could be implemented in a user space server.
     */

  case V_VERIFY: { /* verify the disk */
    unsigned int snum;
    int xcount;
    int code = 0;
    bp1 = geteblk(PAGESIZ);
    bp1->b_flags = B_READ;
    bp1->b_blkno = pchd_abs_sec;
    bp1->b_dev = unit << 4;  /* the minor number */
    xcount = pchd_abs_count;
    snum = PAGESIZ >> 9;
    while (xcount > 0) {
      i = (xcount > snum) ? snum : xcount;
      bp1->b_bcount = i << 9;
      pchdstrategy(bp1);
      biowait(bp1);
      if (bp1->b_flags & B_ERROR) {
	code = BAD_BLK;
	break;
      }
      xcount -= i;
      bp1->b_blkno += i;
      bp1->b_flags &= ~B_DONE;
    }
    brelse(bp1);
    data[0] = code;
    *count = 1;
    break;
  }
  default: /* yargh! wrong flavor */
    return (D_INVALID_OPERATION);
  }
  return (D_SUCCESS);
}

/*--------------------------------------------------------------------------*\
  pchdsetstat

  DESCRIPTION:
    sets some internal hd driver data.

  PARAMETERS: 
    dev: [in] the device to modify.
    flavor: [in] the flavor of data to modify: V_REMOUNT to remount the 
      device (a no-op) or V_ABS to modify the V_VERIFY parameters.
    data: [in] the new values.
    count: [in] the size of data.

  RETURNS:
    D_SUCCESS on success, an error code on error.
\*--------------------------------------------------------------------------*/
io_return_t
pchdsetstat(dev_t dev, int flavor, int *data, unsigned int count)
{
  io_return_t		errcode = D_SUCCESS;  /* the return value */
  int			unit = UNIT(dev);     /* the device unit */

  switch (flavor) {
  case V_REMOUNT: /* remount: no-op */
    break;

    /*
     * If the V_VERIFY option of pchdgetstat is removes, this option must
     * also be removed.
     */

  case V_ABS:     /* change the abs values */
    pchd_abs_sec = *(int *)data;
    if (count == 2)
      pchd_abs_count = data[1];
    break;
  default: /* yargh! invalid flavor */
    return (D_INVALID_OPERATION);
  }
  return (errcode);
}

#else	MACH_KERNEL
/*--------------------------------------------------------------------------*\
  pchdioctl

  DESCRIPTION:
    some kind of ioctl call for user level functions?

  PARAMETERS:
    dev: [in] the device we are querying.
    cmd: [in] the manipulation do perform.
    arg: [in out] arguments to cmd.
    mode: unused. (It is present to be coherent with other ioctl funcs.

  RETURNS:
    0 on success, an error code on error.
\*--------------------------------------------------------------------------*/
int
pchdioctl(dev_t dev, int cmd, caddr_t arg, int mode)
{
  unsigned char unit = UNIT(dev);  /* the unit of the device */
  unsigned char ctrl = unit>>1;    /* the controler of this unit */
  int snum;                        /* number of sectors fitting in a page */
  int xcount;                      /* the number of sectors to verify */
  int i;                           /* generic index */
  struct buf *bp1;                 /* buffer used in V_VERIFY */
  
  switch (cmd) {
  case V_REMOUNT: /* remount the device: a no-op */
    break;
  case V_ADDBAD:  /* this adds a bad block to IN CORE alts table ONLY */
    alt_info[unit].alt_sec.alt_used++;
    alt_info[unit].alt_sec.alt_bad[alt_info[unit].alt_sec.alt_used]
      = ((union io_arg *)arg)->ia_abs.bad_sector;
    break;
  case V_GETPARMS: /* get the hd dosparms */
    {
      struct disk_parms *disk_parms = (struct disk_parms *)arg;
      disk_parms->dp_type = DPT_WINI;
      disk_parms->dp_heads = 0;
      disk_parms->dp_cyls = 0;
      disk_parms->dp_sectors = 0;
      disk_parms->dp_dosheads = dosparm[unit].nheads;
      disk_parms->dp_doscyls = dosparm[unit].ncyl;
      disk_parms->dp_dossectors  = dosparm[unit].nsec;
      disk_parms->dp_secsiz = dosparm[unit].secsize;
      disk_parms->dp_ptag = 0;
      disk_parms->dp_pflag = 0;
      disk_parms->dp_pstartsec = 0;
      disk_parms->dp_pnumsec = 0;
      break;
    }

    /*
     * This could be thrown away and implemented in user space.
     */

  case V_VERIFY: /* verify some sectors */
    if (u.u_uid)
      return(ENXIO);
    bp1 = geteblk(PAGESIZ);
    bp1->b_flags = B_READ;
    bp1->b_blkno = ((union vfy_io *)arg)->vfy_in.abs_sec;
    bp1->b_dev = unit << 4; /* the minor number */
    xcount = ((union vfy_io *)arg)->vfy_in.num_sec;
    ((union vfy_io *)arg)->vfy_out.err_code = 0;
    snum = PAGESIZ >> 9;
    while (xcount > 0) {
      i = (xcount > snum) ? snum : xcount;
      bp1->b_bcount = i << 9;
      pchdstrategy(bp1);
      biowait(bp1);
      if (bp1->b_flags & B_ERROR) {
	((union vfy_io *)arg)->vfy_out.err_code=BAD_BLK;
	break;
      }
      xcount -= i;
      bp1->b_blkno += i;
      bp1->b_flags &= ~B_DONE;
    }
    brelse(bp1);
    break;
  default: /* yargh! wrong cmd */
    return(EINVAL);
  }
  return(0);
}
#endif	MACH_KERNEL


/*---------------------------------------------------------------------------*\
  pchdstrategy

  DESCRIPTION:
    Enqueues the I/O request on the device request queue, sorts the queue and 
    starts the I/O handler of the queue if needed.

  PARAMETERS:
    bp: [in] the new I/O request.

  RETURNS:
    Nothing. The real return information is stored in the bp structure.
\*---------------------------------------------------------------------------*/
void
pchdstrategy(struct buf *bp)
{
  unsigned char unit = UNIT(bp->b_dev); /* device unit we are controling */
  unsigned char ctrl = unit>>1;         /* the controler of the device   */
  struct disklabel *lp = &label[unit];  /* the disklabel of the unit */
  spl_t	opri;                           /* buffer for interrupt levels */

  if (!bp->b_bcount)
    goto done;                          /* nothing to do */

  /* boundary checking */
  if(bp->b_blkno >= dosparm[unit].nsects) {
    bp->b_flags = ENXIO;
    goto bad;
  }
  
  bp->b_physblock=bp->b_blkno;
  bp->b_blocktotal=bp->b_blocktotal = (bp->b_bcount + 511) >> 9;
  
  bp->b_cylin = bp->b_blkno / (lp->d_nsectors * lp->d_ntracks);

  /* let's start that operation */
  opri = spl5();
  disksort(&hdunit[unit], bp);    
  if (!hh[ctrl].controller_busy)
    hdstart(ctrl);
  splx(opri);
  return;

 bad:
  bp->b_flags |= B_ERROR;
 done:
  iodone(bp);
  return;
}

#endif









